diff -r 4d2ecbb9bb2a trytond/modules/stock_forecast/tests/test_stock_forecast.py
--- a/trytond/modules/stock_forecast/tests/test_stock_forecast.py	Mon Sep 10 15:28:40 2012 +0200
+++ b/trytond/modules/stock_forecast/tests/test_stock_forecast.py	Mon Sep 24 20:36:43 2012 +0200
@@ -66,78 +66,73 @@
         Test create_moves.
         '''
         with Transaction().start(DB_NAME, USER, context=CONTEXT):
-            category_id = self.category.create({
+            category = self.category.create({
                     'name': 'Test create_moves',
                     })
-            unit_id, = self.uom.search([('name', '=', 'Unit')])
-            product_id = self.product.create({
+            unit, = self.uom.search([('name', '=', 'Unit')])
+            product = self.product.create({
                     'name': 'Test create_moves',
                     'type': 'goods',
-                    'category': category_id,
+                    'category': category.id,
                     'cost_price_method': 'fixed',
-                    'default_uom': unit_id,
+                    'default_uom': unit.id,
                     'list_price': Decimal('1'),
                     'cost_price': Decimal(0),
                     })
-            customer_id, = self.location.search([('code', '=', 'CUS')])
-            warehouse_id, = self.location.search([('code', '=', 'WH')])
-            storage_id, = self.location.search([('code', '=', 'STO')])
-            company_id, = self.company.search([('name', '=', 'B2CK')])
-            self.user.write(USER, {
-                    'main_company': company_id,
-                    'company': company_id,
+            customer, = self.location.search([('code', '=', 'CUS')])
+            warehouse, = self.location.search([('code', '=', 'WH')])
+            storage, = self.location.search([('code', '=', 'STO')])
+            company, = self.company.search([('name', '=', 'B2CK')])
+            self.user.write([self.user(USER)], {
+                    'main_company': company.id,
+                    'company': company.id,
                     })
 
             today = datetime.date.today()
 
-            forecast_id = self.forecast.create({
-                    'warehouse': warehouse_id,
-                    'destination': customer_id,
+            forecast = self.forecast.create({
+                    'warehouse': warehouse.id,
+                    'destination': customer.id,
                     'from_date': today + relativedelta(months=1, day=1),
                     'to_date': today + relativedelta(months=1, day=20),
-                    'company': company_id,
+                    'company': company.id,
                     'lines': [
                         ('create', {
-                                'product': product_id,
+                                'product': product.id,
                                 'quantity': 10,
-                                'uom': unit_id,
+                                'uom': unit.id,
                                 'minimal_quantity': 2,
                                 },
                             ),
                         ],
                     })
-            self.forecast.confirm([forecast_id])
+            self.forecast.confirm([forecast])
 
-            self.forecast.create_moves([forecast_id])
-            forecast = self.forecast.browse(forecast_id)
+            self.forecast.create_moves([forecast])
             line, = forecast.lines
             self.assertEqual(line.quantity_executed, 0)
             self.assertEqual(len(line.moves), 5)
             self.assertEqual(sum(move.quantity for move in line.moves), 10)
 
-            self.forecast.delete_moves([forecast_id])
-            forecast = self.forecast.browse(forecast_id)
+            self.forecast.delete_moves([forecast])
             line, = forecast.lines
             self.assertEqual(len(line.moves), 0)
 
-            company = self.company.browse(company_id)
             self.move.create({
-                    'from_location': storage_id,
-                    'to_location': customer_id,
-                    'product': product_id,
-                    'uom': unit_id,
+                    'from_location': storage.id,
+                    'to_location': customer.id,
+                    'product': product.id,
+                    'uom': unit.id,
                     'quantity': 2,
                     'planned_date': today + relativedelta(months=1, day=5),
-                    'company': company_id,
+                    'company': company.id,
                     'currency': company.currency.id,
                     'unit_price': Decimal('1'),
                     })
-            forecast = self.forecast.browse(forecast_id)
             line, = forecast.lines
             self.assertEqual(line.quantity_executed, 2)
 
-            self.forecast.create_moves([forecast_id])
-            forecast = self.forecast.browse(forecast_id)
+            self.forecast.create_moves([forecast])
             line, = forecast.lines
             self.assertEqual(line.quantity_executed, 2)
             self.assertEqual(len(line.moves), 4)
diff -r 23e95b2814bb trytond/modules/stock_inventory_location/__init__.py
--- a/trytond/modules/stock_inventory_location/__init__.py	Fri Jun 08 19:34:29 2012 +0200
+++ b/trytond/modules/stock_inventory_location/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,4 +1,14 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .inventory import *
+
+
+def register():
+    Pool.register(
+        CreateInventoriesStart,
+        module='stock_inventory_location', type_='model')
+    Pool.register(
+        CreateInventories,
+        module='stock_inventory_location', type_='wizard')
diff -r 23e95b2814bb trytond/modules/stock_inventory_location/inventory.py
--- a/trytond/modules/stock_inventory_location/inventory.py	Fri Jun 08 19:34:29 2012 +0200
+++ b/trytond/modules/stock_inventory_location/inventory.py	Mon Sep 24 20:36:43 2012 +0200
@@ -5,12 +5,12 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['CreateInventoriesStart', 'CreateInventories']
+
 
 class CreateInventoriesStart(ModelView):
     'Create Inventories'
-    _name = 'stock.inventory.create.start'
-    _description = __doc__
-
+    __name__ = 'stock.inventory.create.start'
     date = fields.Date('Date', required=True)
     lost_found = fields.Many2One(
         'stock.location', 'Lost and Found', required=True,
@@ -20,22 +20,21 @@
     locations = fields.Many2Many('stock.location', None, None,
             'Locations', required=True, domain=[('type', '=', 'storage')])
 
-    def default_lost_found(self):
-        location_obj = Pool().get('stock.location')
-        location_ids = location_obj.search(self.lost_found.domain)
-        if len(location_ids) == 1:
-            return location_ids[0]
+    @classmethod
+    def default_lost_found(cls):
+        Location = Pool().get('stock.location')
+        locations = Location.search(cls.lost_found.domain)
+        if len(locations) == 1:
+            return locations[0].id
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-CreateInventoriesStart()
-
 
 class CreateInventories(Wizard):
     'Create Inventories'
-    _name = 'stock.inventory.create'
-
+    __name__ = 'stock.inventory.create'
     start = StateView('stock.inventory.create.start',
         'stock_inventory_location.inventory_create_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -43,24 +42,19 @@
             ])
     create_ = StateAction('stock.act_inventory_form')
 
-    def do_create_(self, session, action):
-        pool = Pool()
-        inventory_obj = pool.get('stock.inventory')
+    def do_create_(self, action):
+        Inventory = Pool().get('stock.inventory')
 
-        inventory_ids = []
-        location_ids = [x.id for x in session.start.locations]
-
-        for location_id in location_ids:
-            inventory_ids.append(inventory_obj.create({
-                        'location': location_id,
-                        'date': session.start.date,
-                        'lost_found': session.start.lost_found.id,
-                        'company': session.start.company.id,
+        inventories = []
+        for location in self.start.locations:
+            inventories.append(Inventory.create({
+                        'location': location.id,
+                        'date': self.start.date,
+                        'lost_found': self.start.lost_found.id,
+                        'company': self.start.company.id,
                         }))
 
-        inventory_obj.complete_lines(inventory_ids)
+        Inventory.complete_lines(inventories)
 
-        data = {'res_id': inventory_ids}
+        data = {'res_id': [i.id for i in inventories]}
         return action, data
-
-CreateInventories()
diff -r c7283a249034 trytond/modules/stock_location_sequence/__init__.py
--- a/trytond/modules/stock_location_sequence/__init__.py	Fri Jun 08 19:34:30 2012 +0200
+++ b/trytond/modules/stock_location_sequence/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .stock import *
+
+
+def register():
+    Pool.register(
+        Location,
+        module='stock_location_sequence', type_='model')
diff -r c7283a249034 trytond/modules/stock_location_sequence/stock.py
--- a/trytond/modules/stock_location_sequence/stock.py	Fri Jun 08 19:34:30 2012 +0200
+++ b/trytond/modules/stock_location_sequence/stock.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,14 +1,18 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level
 #of this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
 from trytond.pyson import Not, Eval, Bool
 from trytond.transaction import Transaction
 from trytond.backend import TableHandler
+from trytond.pool import PoolMeta
 
+__all__ = ['Location']
+__metaclass__ = PoolMeta
 
-class Location(ModelSQL, ModelView):
+
+class Location:
     "Stock Location"
-    _name = 'stock.location'
+    __name__ = 'stock.location'
     sequence = fields.Integer('Sequence',
         order_field='(%(table)s.sequence IS NULL) %(order)s, '
         '%(table)s.sequence %(order)s',
@@ -17,17 +21,17 @@
             },
         depends=['active'])
 
-    def __init__(self):
-        super(Location, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(Location, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(Location, self).init(module_name)
+        super(Location, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
-
-Location()
diff -r e03001f00e60 trytond/modules/stock_lot/__init__.py
--- a/trytond/modules/stock_lot/__init__.py	Tue Jul 31 10:46:25 2012 +0200
+++ b/trytond/modules/stock_lot/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,5 +1,20 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .stock import *
 from .product import *
+
+
+def register():
+    Pool.register(
+        Lot,
+        LotType,
+        Move,
+        ShipmentIn,
+        ShipmentOut,
+        ShipmentOutReturn,
+        Template,
+        Product,
+        TemplateLotType,
+        module='stock_lot', type_='model')
diff -r e03001f00e60 trytond/modules/stock_lot/product.py
--- a/trytond/modules/stock_lot/product.py	Tue Jul 31 10:46:25 2012 +0200
+++ b/trytond/modules/stock_lot/product.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,11 +1,15 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model, ModelSQL, fields
+from trytond.model import ModelSQL, fields
 from trytond.pyson import Eval
+from trytond.pool import PoolMeta
 
+__all__ = ['Template', 'Product', 'TemplateLotType']
+__metaclass__ = PoolMeta
 
-class Template(Model):
-    _name = 'product.template'
+
+class Template:
+    __name__ = 'product.template'
 
     # TODO to replace with a Multiple Selection
     lot_required = fields.Many2Many('product.template-stock.lot.type',
@@ -16,28 +20,22 @@
             },
         depends=['type'])
 
-Template()
 
+class Product:
+    __name__ = 'product.product'
 
-class Product(Model):
-    _name = 'product.product'
-
-    def lot_is_required(self, product, from_, to):
+    def lot_is_required(self, from_, to):
         'Is product lot required for move with "from_" and "to" location ?'
-        lot_required = [t.code for t in product.lot_required]
+        lot_required = [t.code for t in self.lot_required]
         for location in (from_, to):
             if location.type in lot_required:
                 return True
 
-Product()
-
 
 class TemplateLotType(ModelSQL):
     'Template - Stock Lot Type'
-    _name = 'product.template-stock.lot.type'
+    __name__ = 'product.template-stock.lot.type'
 
     template = fields.Many2One('product.template', 'Template', required=True,
         select=True)
     type = fields.Many2One('stock.lot.type', 'Type', required=True)
-
-TemplateLotType()
diff -r e03001f00e60 trytond/modules/stock_lot/stock.py
--- a/trytond/modules/stock_lot/stock.py	Tue Jul 31 10:46:25 2012 +0200
+++ b/trytond/modules/stock_lot/stock.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,36 +1,31 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model, ModelView, ModelSQL, Workflow, fields
+from trytond.model import ModelView, ModelSQL, Workflow, fields
 from trytond.pyson import Eval
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
+
+__all__ = ['Lot', 'LotType', 'Move', 'ShipmentIn', 'ShipmentOut',
+    'ShipmentOutReturn']
+__metaclass__ = PoolMeta
 
 
 class Lot(ModelSQL, ModelView):
     "Stock Lot"
-    _name = 'stock.lot'
-    _description = __doc__
+    __name__ = 'stock.lot'
     _rec_name = 'number'
-
     number = fields.Char('Number', required=True, select=True)
     product = fields.Many2One('product.product', 'Product', required=True)
 
-Lot()
-
 
 class LotType(ModelSQL, ModelView):
     "Stock Lot Type"
-    _name = 'stock.lot.type'
-    _description = __doc__
-
+    __name__ = 'stock.lot.type'
     name = fields.Char('Name', required=True, translate=True)
     code = fields.Char('Code', required=True)
 
-LotType()
 
-
-class Move(Model):
-    _name = 'stock.move'
-
+class Move:
+    __name__ = 'stock.move'
     lot = fields.Many2One('stock.lot', 'Lot',
         domain=[
             ('product', '=', Eval('product')),
@@ -40,66 +35,61 @@
             },
         depends=['state', 'product'])
 
-    def __init__(self):
-        super(Move, self).__init__()
-        self._error_messages.update({
+    @classmethod
+    def __setup__(cls):
+        super(Move, cls).__setup__()
+        cls._error_messages.update({
                 'lot_required': 'Lot is required for move of product "%s"!',
                 })
 
-    def check_lot(self, ids):
+    @classmethod
+    def check_lot(cls, moves):
         "Check if lot is required"
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        for move in self.browse(ids):
+        for move in moves:
             if (move.state == 'done'
                     and not move.lot
-                    and product_obj.lot_is_required(move.product,
+                    and move.product.lot_is_required(
                         move.from_location, move.to_location)):
-                self.raise_user_error('lot_required', (move.product.rec_name,))
+                cls.raise_user_error('lot_required', (move.product.rec_name,))
 
-    def create(self, values):
-        new_id = super(Move, self).create(values)
-        self.check_lot([new_id])
-        return new_id
+    @classmethod
+    def create(cls, values):
+        move = super(Move, cls).create(values)
+        cls.check_lot([move])
+        return move
 
-    def write(self, ids, values):
-        result = super(Move, self).write(ids, values)
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_lot(ids)
-        return result
+    @classmethod
+    def write(cls, moves, values):
+        super(Move, cls).write(moves, values)
+        cls.check_lot(moves)
 
-Move()
 
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
 
-class ShipmentIn(Model):
-    _name = 'stock.shipment.in'
-
-    def _get_inventory_moves(self, incoming_move):
-        result = super(ShipmentIn, self)._get_inventory_moves(incoming_move)
-        if result:
+    @classmethod
+    def _get_inventory_moves(cls, incoming_move):
+        result = super(ShipmentIn, cls)._get_inventory_moves(incoming_move)
+        if result and incoming_move.lot:
             result['lot'] = incoming_move.lot.id
         return result
 
-ShipmentIn()
 
+class ShipmentOut:
+    __name__ = 'stock.shipment.out'
 
-class ShipmentOut(Model):
-    _name = 'stock.shipment.out'
-
+    @classmethod
     @ModelView.button
     @Workflow.transition('packed')
-    def pack(self, ids):
+    def pack(cls, shipments):
         pool = Pool()
-        uom_obj = pool.get('product.uom')
-        move_obj = pool.get('stock.move')
+        Uom = pool.get('product.uom')
+        Move = pool.get('stock.move')
 
-        super(ShipmentOut, self).pack(ids)
-
-        shipments = self.browse(ids)
+        super(ShipmentOut, cls).pack(shipments)
 
         # Unassign move to allow update
-        move_obj.write([m.id for s in shipments for m in s.outgoing_moves
+        Move.write([m for s in shipments for m in s.outgoing_moves
                 if m.state not in ('done', 'cancel')], {
                 'state': 'draft',
                 })
@@ -112,47 +102,40 @@
             for move in shipment.inventory_moves:
                 if not move.lot:
                     continue
-                quantity = uom_obj.compute_qty(move.uom, move.quantity,
+                quantity = Uom.compute_qty(move.uom, move.quantity,
                     move.product.default_uom, round=False)
                 outgoing_moves = outgoing_by_product[move.product.id]
                 while outgoing_moves and quantity > 0:
                     out_move = outgoing_moves.pop()
-                    out_quantity = uom_obj.compute_qty(out_move.uom,
+                    out_quantity = Uom.compute_qty(out_move.uom,
                         out_move.quantity, out_move.product.default_uom,
                         round=False)
                     if quantity < out_quantity:
-                        outgoing_moves.append(move_obj.browse(
-                                move_obj.copy(out_move.id, default={
-                                        'quantity': out_quantity - quantity,
-                                        })))
-                        move_obj.write(out_move.id, {
+                        outgoing_moves.extend(Move.copy([out_move], default={
+                                    'quantity': out_quantity - quantity,
+                                    }))
+                        Move.write([out_move], {
                                 'quantity': quantity,
                                 })
-                    move_obj.write(out_move.id, {
+                    Move.write([out_move], {
                             'lot': move.lot.id,
                             })
                     quantity -= out_quantity
                 assert quantity <= 0
 
-        # Reset function field cache
-        shipments = self.browse(ids)
-
-        move_obj.write([m.id for s in shipments for m in s.outgoing_moves
+        Move.write([m for s in shipments for m in s.outgoing_moves
                 if m.state != 'cancel'], {
                 'state': 'assigned',
                 })
 
-ShipmentOut()
 
+class ShipmentOutReturn:
+    __name__ = 'stock.shipment.out.return'
 
-class ShipmentOutReturn(Model):
-    _name = 'stock.shipment.out.return'
-
-    def _get_inventory_moves(self, incoming_move):
+    @classmethod
+    def _get_inventory_moves(cls, incoming_move):
         result = super(ShipmentOutReturn,
-            self)._get_inventory_moves(incoming_move)
-        if result:
+            cls)._get_inventory_moves(incoming_move)
+        if result and incoming_move.lot:
             result['lot'] = incoming_move.lot.id
         return result
-
-ShipmentOutReturn()
diff -r f78800bc9893 trytond/modules/stock_product_location/__init__.py
--- a/trytond/modules/stock_product_location/__init__.py	Fri Jun 08 19:34:31 2012 +0200
+++ b/trytond/modules/stock_product_location/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,5 +1,14 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .product import *
 from .location import *
+
+
+def register():
+    Pool.register(
+        Product,
+        ProductLocation,
+        ShipmentIn,
+        module='stock_product_location', type_='model')
diff -r f78800bc9893 trytond/modules/stock_product_location/location.py
--- a/trytond/modules/stock_product_location/location.py	Fri Jun 08 19:34:31 2012 +0200
+++ b/trytond/modules/stock_product_location/location.py	Mon Sep 24 20:36:43 2012 +0200
@@ -4,16 +4,18 @@
 from trytond.pyson import If, Eval, Bool
 from trytond.transaction import Transaction
 from trytond.backend import TableHandler
+from trytond.pool import PoolMeta
+
+__all__ = ['ProductLocation', 'ShipmentIn']
+__metaclass__ = PoolMeta
 
 
 class ProductLocation(ModelSQL, ModelView):
     '''
-    Product Location defines the default storage location
-    by warehouse for a product
+    Product Location
+    It defines the default storage location by warehouse for a product.
     '''
-    _name = 'stock.product.location'
-    _description = 'Product Location'
-
+    __name__ = 'stock.product.location'
     product = fields.Many2One('product.product', 'Product', required=True,
             select=True)
     warehouse = fields.Many2One('stock.location', 'Warehouse', required=True,
@@ -28,32 +30,31 @@
         order_field='(%(table)s.sequence IS NULL) %(order)s, '
         '%(table)s.sequence %(order)s')
 
-    def __init__(self):
-        super(ProductLocation, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductLocation, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(ProductLocation, self).init(module_name)
+        super(ProductLocation, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-ProductLocation()
 
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
 
-class ShipmentIn(ModelSQL, ModelView):
-    _name = 'stock.shipment.in'
-
-    def _get_inventory_moves(self, incoming_move):
-        res = super(ShipmentIn, self)._get_inventory_moves(incoming_move)
+    @classmethod
+    def _get_inventory_moves(cls, incoming_move):
+        res = super(ShipmentIn, cls)._get_inventory_moves(incoming_move)
         for product_location in incoming_move.product.locations:
             if product_location.warehouse.id != \
                     incoming_move.shipment_in.warehouse.id:
                 continue
             res['to_location'] = product_location.location.id
         return res
-
-ShipmentIn()
diff -r f78800bc9893 trytond/modules/stock_product_location/product.py
--- a/trytond/modules/stock_product_location/product.py	Fri Jun 08 19:34:31 2012 +0200
+++ b/trytond/modules/stock_product_location/product.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,15 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import ModelView, ModelSQL, fields
+from trytond.model import fields
 from trytond.pyson import Eval
+from trytond.pool import PoolMeta
 
+__all__ = ['Product']
+__metaclass__ = PoolMeta
 
-class Product(ModelSQL, ModelView):
-    _name = 'product.product'
 
+class Product:
+    __name__ = 'product.product'
     locations = fields.One2Many('stock.product.location', 'product',
         'Default Locations', states={
             'invisible': ~Eval('type').in_(['goods', 'assets']),
             })
-
-Product()
diff -r f2000f2db021 trytond/modules/stock_split/__init__.py
--- a/trytond/modules/stock_split/__init__.py	Mon Sep 10 15:28:47 2012 +0200
+++ b/trytond/modules/stock_split/__init__.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,4 +1,15 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of this
 #repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .stock import *
+
+
+def register():
+    Pool.register(
+        Move,
+        SplitMoveStart,
+        module='stock_split', type_='model')
+    Pool.register(
+        SplitMove,
+        module='stock_split', type_='wizard')
diff -r f2000f2db021 trytond/modules/stock_split/stock.py
--- a/trytond/modules/stock_split/stock.py	Mon Sep 10 15:28:47 2012 +0200
+++ b/trytond/modules/stock_split/stock.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,46 +1,51 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-from trytond.model import Model, ModelView, fields
+from trytond.model import ModelView, fields
 from trytond.wizard import Wizard, StateView, StateTransition, Button
 from trytond.pyson import Eval
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 
+__all__ = ['Move', 'SplitMoveStart', 'SplitMove']
+__metaclass__ = PoolMeta
 
-class Move(Model):
-    _name = 'stock.move'
 
-    def __init__(self):
-        super(Move, self).__init__()
-        self._buttons.update({
+class Move:
+    __name__ = 'stock.move'
+
+    @classmethod
+    def __setup__(cls):
+        super(Move, cls).__setup__()
+        cls._buttons.update({
                 'split_wizard': {
                     'readonly': ~Eval('state').in_(['draft', 'assigned']),
                     },
                 })
 
+    @classmethod
     @ModelView.button_action('stock_split.wizard_split_move')
-    def split_wizard(self, ids):
+    def split_wizard(cls, moves):
         pass
 
-    def split(self, move, quantity, uom, count=None):
+    def split(self, quantity, uom, count=None):
         """
         Split the move into moves of quantity.
         If count is not defined, the move will be split until the remainder is
         less than quantity.
-        Return the split move ids
+        Return the split moves
         """
         pool = Pool()
-        uom_obj = pool.get('product.uom')
+        Uom = pool.get('product.uom')
 
-        moves = [move.id]
-        remainder = uom_obj.compute_qty(move.uom, move.quantity, uom)
+        moves = [self]
+        remainder = Uom.compute_qty(self.uom, self.quantity, uom)
         if remainder <= quantity:
             return moves
-        state = move.state
-        self.write(move.id, {
+        state = self.state
+        self.write([self], {
                 'state': 'draft',
                 })
-        self.write(move.id, {
+        self.write([self], {
                 'quantity': quantity,
                 'uom': uom.id,
                 'state': state,
@@ -50,7 +55,7 @@
             count -= 1
         while (remainder > quantity
                 and (count or count is None)):
-            moves.append(self.copy(move.id, {
+            moves.extend(self.copy([self], {
                         'quantity': quantity,
                         'uom': uom.id,
                         'state': state,
@@ -60,21 +65,17 @@
                 count -= 1
         assert remainder >= 0
         if remainder:
-            moves.append(self.copy(move.id, {
+            moves.extend(self.copy([self], {
                         'quantity': remainder,
                         'uom': uom.id,
                         'state': state,
                         }))
         return moves
 
-Move()
-
 
 class SplitMoveStart(ModelView):
     'Split Move'
-    _name = 'stock.move.split.start'
-    _description = __doc__
-
+    __name__ = 'stock.move.split.start'
     count = fields.Integer('Counts', help='The limit number of moves')
     quantity = fields.Float('Quantity', required=True,
         digits=(16, Eval('unit_digits', 2)),
@@ -89,21 +90,15 @@
     uom_category = fields.Many2One('product.uom.category', 'Uom Category',
         readonly=True)
 
-    def on_change_with_unit_digits(self, values):
-        pool = Pool()
-        uom_obj = pool.get('product.uom')
-        if values.get('uom'):
-            uom = uom_obj.browse(values['uom'])
-            return uom.digits
+    def on_change_with_unit_digits(self):
+        if self.uom:
+            return self.uom.digits
         return 2
 
-SplitMoveStart()
-
 
 class SplitMove(Wizard):
     'Split Move'
-    _name = 'stock.move.split'
-
+    __name__ = 'stock.move.split'
     start = StateView('stock.move.split.start',
         'stock_split.split_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -111,22 +106,19 @@
             ])
     split = StateTransition()
 
-    def default_start(self, session, fields):
+    def default_start(self, fields):
         pool = Pool()
-        move_obj = pool.get('stock.move')
+        Move = pool.get('stock.move')
         default = {}
-        move = move_obj.browse(Transaction().context['active_id'])
+        move = Move(Transaction().context['active_id'])
         default['uom'] = move.uom.id
         default['unit_digits'] = move.unit_digits
         default['uom_category'] = move.uom.category.id
         return default
 
-    def transition_split(self, session):
+    def transition_split(self):
         pool = Pool()
-        move_obj = pool.get('stock.move')
-        move = move_obj.browse(Transaction().context['active_id'])
-        move_obj.split(move, session.start.quantity, session.start.uom,
-            session.start.count)
+        Move = pool.get('stock.move')
+        move = Move(Transaction().context['active_id'])
+        move.split(self.start.quantity, self.start.uom, self.start.count)
         return 'end'
-
-SplitMove()
